#include "type.h"
#include "init.h"
#include "mem.h"
#include "opdef.h"
#include "cpu2.h"
#include "gte.h"
#include "bios.h"
#include "hw.h"
#include "compile.h"
#include "win.h"
#include "runtime.h"
#include "cdrom.h"
#include "dis.h"
#include "cd.h"
#include "sio.h"
#include "rs232.h"
#include "joydrv.h"
#include "joypad.h"
#include "mdec.h"
#include "gpu.h"
#include "spu.h"

// FPSE compiled version (BCD format)
#define FPSE_VERSION    0x0008

// add-on
#define FRAMESKIP   0
#define AUTOSPEED   0

// Flags
#define DISASMFLG       0x0001
#define EMULATE_BIOS    0x0002
#define VERBOSE         0x0004
#define IN_SLOT         0x0008
#define STOP            0x0010
#define SET_ESI         0x0020
#define COMPILE         0x0040
#define CDUSECACHE      0x0080
#define DEBUG           0x0100
#define ACTIONREPLAY    0x0200

#define PSX_COUNTRY     0x030000

// Other Flags in FPSE_Flags:
///////////////////////////////
// Country USA    = 0x010000
// Country Europe = 0x020000
// Country Japan  = 0x030000

#define USE_AMERICAN_PSX  0x010000
#define USE_EUROPE_PSX    0x020000
#define USE_JAPAN_PSX     0x030000

#define disasmflg       (FPSE_Flags & DISASMFLG)
#define emulate_bios    (FPSE_Flags & EMULATE_BIOS)
#define verbose         (FPSE_Flags & VERBOSE)
#define in_slot         (FPSE_Flags & IN_SLOT)
#define stop            (FPSE_Flags & STOP)
#define compile         (FPSE_Flags & COMPILE)
#define cdusecache      (FPSE_Flags & CDUSECACHE)
#define debug           (FPSE_Flags & DEBUG)
#define actionreplay    (FPSE_Flags & ACTIONREPLAY)
#define psx_country     (FPSE_Flags & PSX_COUNTRY)

#define PRINTF  if (verbose) printf

typedef struct {
    char   *BiosName;
    char   *ComName;
    char   *Mcd1Name;
    char   *Mcd2Name;
} FPSECfgType;

void run_debug(void);
void LoadCFG(void);

extern UINT8   *ram;
extern UINT8   *rom;
extern UINT8   *scratchpad;
extern UINT8   *extrom;
extern FPSECfgType FPSEIni;

extern R3000_REG reg;
extern int       Irq_Pulse;
extern int       FPSE_Flags;
